!> @file user_last_actions.f90
!------------------------------------------------------------------------------!
! This file is part of PALM.
!
! PALM is free software: you can redistribute it and/or modify it under the
! terms of the GNU General Public License as published by the Free Software
! Foundation, either version 3 of the License, or (at your option) any later
! version.
!
! PALM is distributed in the hope that it will be useful, but WITHOUT ANY
! WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
! A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License along with
! PALM. If not, see <http://www.gnu.org/licenses/>.
!
! Copyright 1997-2017 Leibniz Universitaet Hannover
!------------------------------------------------------------------------------!
!
! Current revisions:
! -----------------
! 
! 
! Former revisions:
! -----------------
! $Id: user_last_actions.f90 2101 2017-01-05 16:42:31Z suehring $
!
! 2000 2016-08-20 18:09:15Z knoop
! Forced header and separation lines into 80 columns
! 
! 1682 2015-10-07 23:56:08Z knoop
! Code annotations made doxygen readable 
!
! 1320 2014-03-20 08:40:49Z raasch
! revision history before 2012 removed
!
! 1036 2012-10-22 13:43:42Z raasch
! code put under GPL (PALM 3.9)
!
! 211 2008-11-11 04:46:24Z raasch
! Former file user_interface.f90 split into one file per subroutine
!
! Description:
! ------------
!> Execution of user-defined actions at the end of a job.
!------------------------------------------------------------------------------!
 SUBROUTINE user_last_actions
 

    USE control_parameters
        
    USE kinds
    
    USE user

    IMPLICIT NONE

!
!-- Here the user-defined actions at the end of a job follow.
!-- Sample for user-defined output:
    IF ( write_binary )  THEN
       IF ( ALLOCATED( usss_res_av ) )  THEN
          WRITE ( 14 )  'usss_res_av         ';  WRITE ( 14 )  usss_res_av 
       ENDIF
       IF ( ALLOCATED( vsss_res_av ) )  THEN
          WRITE ( 14 )  'vsss_res_av         ';  WRITE ( 14 )  vsss_res_av 
       ENDIF
       IF ( ALLOCATED( wsss_res_av ) )  THEN
          WRITE ( 14 )  'wsss_res_av         ';  WRITE ( 14 )  wsss_res_av 
       ENDIF
       IF ( ALLOCATED( usss_sgs_av ) )  THEN
          WRITE ( 14 )  'usss_sgs_av         ';  WRITE ( 14 )  usss_sgs_av 
       ENDIF
       IF ( ALLOCATED( vsss_sgs_av ) )  THEN
          WRITE ( 14 )  'vsss_sgs_av         ';  WRITE ( 14 )  vsss_sgs_av 
       ENDIF
       IF ( ALLOCATED( wsss_sgs_av ) )  THEN
          WRITE ( 14 )  'wsss_sgs_av         ';  WRITE ( 14 )  wsss_sgs_av 
       ENDIF
!
!--    Balance terms
       IF ( ALLOCATED( dsdt_av ) )  THEN
          WRITE ( 14 )  'dsdt_av             ';  WRITE ( 14 )  dsdt_av 
       ENDIF
       
       IF ( ALLOCATED( div_res_av ) )  THEN
          WRITE ( 14 )  'div_av              ';  WRITE ( 14 )  div_res_av 
       ENDIF       
       IF ( ALLOCATED( d_usss_res_av ) )  THEN
          WRITE ( 14 )  'dusss_res_av        ';  WRITE ( 14 )  d_usss_res_av 
       ENDIF
       IF ( ALLOCATED( d_vsss_res_av ) )  THEN
          WRITE ( 14 )  'dvsss_res_av        ';  WRITE ( 14 )  d_vsss_res_av 
       ENDIF
       IF ( ALLOCATED( d_wsss_res_av ) )  THEN
          WRITE ( 14 )  'dwsss_res_av        ';  WRITE ( 14 )  d_wsss_res_av 
       ENDIF
       IF ( ALLOCATED( d_usss_sgs_av ) )  THEN
          WRITE ( 14 )  'dusss_sgs_av        ';  WRITE ( 14 )  d_usss_sgs_av 
       ENDIF
       IF ( ALLOCATED( d_vsss_sgs_av ) )  THEN
          WRITE ( 14 )  'dvsss_sgs_av        ';  WRITE ( 14 )  d_vsss_sgs_av 
       ENDIF
       IF ( ALLOCATED( d_wsss_sgs_av ) )  THEN
          WRITE ( 14 )  'dwsss_sgs_av        ';  WRITE ( 14 )  d_wsss_sgs_av 
       ENDIF

       IF ( ALLOCATED( uu_av ) )  THEN
          WRITE ( 14 )  'uu_av               ';  WRITE ( 14 )  uu_av 
       ENDIF
       IF ( ALLOCATED( vv_av ) )  THEN
          WRITE ( 14 )  'vv_av               ';  WRITE ( 14 )  vv_av 
       ENDIF
       IF ( ALLOCATED( ww_av ) )  THEN
          WRITE ( 14 )  'ww_av               ';  WRITE ( 14 )  ww_av 
       ENDIF
       IF ( ALLOCATED( u_plus_av ) )  THEN
          WRITE ( 14 )  'u_plus_av           ';  WRITE ( 14 )  u_plus_av 
       ENDIF
       IF ( ALLOCATED( v_plus_av ) )  THEN
          WRITE ( 14 )  'v_plus_av           ';  WRITE ( 14 )  v_plus_av 
       ENDIF
       IF ( ALLOCATED( w_plus_av ) )  THEN
          WRITE ( 14 )  'w_plus_av           ';  WRITE ( 14 )  w_plus_av 
       ENDIF
       IF ( ALLOCATED( u_minus_av ) )  THEN
          WRITE ( 14 )  'u_minus_av          ';  WRITE ( 14 )  u_minus_av 
       ENDIF
       IF ( ALLOCATED( v_minus_av ) )  THEN
          WRITE ( 14 )  'v_minus_av          ';  WRITE ( 14 )  v_minus_av 
       ENDIF
       IF ( ALLOCATED( w_minus_av ) )  THEN
          WRITE ( 14 )  'w_minus_av          ';  WRITE ( 14 )  w_minus_av 
       ENDIF
       IF ( ALLOCATED( ff_av ) )  THEN
          WRITE ( 14 )  'ff_av               ';  WRITE ( 14 )  ff_av
       ENDIF
       IF ( ALLOCATED( ff_h_av ) )  THEN
          WRITE ( 14 )  'ff_h_av             ';  WRITE ( 14 )  ff_h_av
       ENDIF

       WRITE ( 14 )  '*** end user ***    '

    ENDIF
!
!-- Close ASCII files
    IF ( residence )  THEN
       CLOSE ( 220 )
    ENDIF

 END SUBROUTINE user_last_actions

